//+------------------------------------------------------------------+
//|                                                    Staircase.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window

#property  indicator_buffers 2
#property  indicator_color1  White
#property  indicator_style1  STYLE_SOLID
#property  indicator_width1  1
#property  indicator_color2  White
#property  indicator_style2  STYLE_SOLID
#property  indicator_width2  1

//#include <WinUser32.mqh>

extern int    ConsecutiveCandles = 2;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

string   ccy, sym, IndiName;
int      dig, tf, tmf;
double   spr, pnt, tickval, bidp, askp, minlot;

double   ind_buffer0[], ind_buffer1[];

//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
  IndiName = "Staircase-";
  IndicatorShortName(IndiName);

  SetIndexBuffer(0,ind_buffer0);
  SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2,White);
  SetIndexArrow(0,242);     // 241 = up arrow; 242 = down arrow
  SetIndexBuffer(1,ind_buffer1);
  SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2,White);
  SetIndexArrow(1,241);     // 241 = up arrow; 242 = down arrow

  sym     = Symbol();
  ccy     = Symbol();
  tmf     = Period();
  bidp    = MarketInfo(ccy,MODE_BID);
  askp    = MarketInfo(ccy,MODE_ASK);
  pnt     = MarketInfo(ccy,MODE_POINT);
  dig     = MarketInfo(ccy,MODE_DIGITS);
  spr     = MarketInfo(ccy,MODE_SPREAD);
  tickval = MarketInfo(ccy,MODE_TICKVALUE);
  minlot  = MarketInfo(ccy,MODE_MINLOT);
  if (dig == 3 || dig == 5) {
    pnt     *= 10;
    spr     /= 10;
    tickval *= 10;
  }  

  return(0);
}

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+
  plot_obj();
  if (alertsOn)
  {
      int forBar = 1; if(alertsOnCurrent) forBar = 0;
         if (ind_buffer0[forBar]!=EMPTY_VALUE) doAlert("down");
         if (ind_buffer1[forBar]!=EMPTY_VALUE) doAlert("up");
  }
  return(0);
}

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," staircase signal ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," staircase"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," staircase "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
void plot_obj()   {
//+------------------------------------------------------------------+
  for (int i=Bars-ConsecutiveCandles-1; i>=0; i--)   {
    bool hc=true, lc=true;
    for (int j=0; j<ConsecutiveCandles; j++)   {
      if (High[i+j] <= High[i+j+1] || Close[i+j] <= Close[i+j+1])   hc=false;
      if (Low[i+j]  >= Low [i+j+1] || Close[i+j] >= Close[i+j+1])   lc=false;
    }
    ind_buffer0[i] = EMPTY_VALUE;
    ind_buffer1[i] = EMPTY_VALUE;
      if (hc) ind_buffer0[i] = High[i] + iATR(NULL,0,15,i)/2;
      if (lc) ind_buffer1[i] = Low[i]  - iATR(NULL,0,15,i)/2;
  }  
  return;
}

